'
' heiseTicker by Nessie (nessie4@gmx.net)
' v 1.0 - July 5th 2004
'
' The german publisher heise (most known by the ct' pc newspaper) has a newsletter on its side.
' These is read by the heiseTicker script and the headlines are stored into scripts\heise.rdf
'
' Perhaps you find it useful (like me)
'
'
' v 1.0 - Initial Version.


'----------------------------------------------------------------------------------------------
' CREDITS
'----------------------------------------------------------------------------------------------
' Thanks goes out to AdamC and his BBC Info as reference, also for samurize developers and
' comunity.


'----------------------------------------------------------------------------------------------
' CONSTANTS - You are welcome to change these to your settings.
'----------------------------------------------------------------------------------------------
Const Browser   = "c:\programme\internet explorer\iexplore.exe" ' To start a new browser window
const heiseURL  = "http://www.heise.de/newsticker/heise.rdf"    ' remote news
const heiseFile = "Scripts\heise.rdf"                           ' local copy
const pollrate  = 15                                            ' time in minutes


'----------------------------------------------------------------------------------------------
' CODE AFTER THIS, DO NOT CHANGE! UNLESS YOU KNOW WHAT YOU ARE DOING
'----------------------------------------------------------------------------------------------
SamurizeDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")


Function GetInformation()
  Dim state
  Set fs = CreateObject("Scripting.FileSystemObject")
  If (Not fs.FileExists(SamurizeDir & heiseFile)) Then
    state = True
  Else
    Set cacheFile = fs.GetFile(SamurizeDir & heiseFile)
    state = False
    If CInt(DateDiff("n", cacheFile.DateLastModified, Now())) >= CInt(pollrate) Then
      state = True
    End If
  End If
  If state Then
    Dim str, regEx, regEx1
    
    Set f = fs.CreateTextFile(SamurizeDir & heiseFile, true, false)

    ' read remote file
    Set Http = CreateObject("Microsoft.XMLhttp")
    Http.Open "GET", heiseURL, False
    Http.Send
    str = BinToText(Http.ResponseBody, Len(Http.ResponseBody))
    Set Http = Nothing
    
    ' cut unneeded newlines    
    Set regEx     = New RegExp 
    regEx.Global  = True
    regEx.Pattern = "\n"
    str = regEx.Replace(str, "")
    Set regEx     = Nothing 

    ' find <item> entries    
    Set regEx = New RegExp 
    regEx.Global = True
    regEx.Pattern = "<item>\n  <title>(.*?)</title>\n  <link>(.*?)</link>" 'Pattern string
    regEx.Pattern = "<item>(.*?)</item>" 'Pattern string
    Set Matches = regEx.Execute(str)
    Set regEx1    = New RegExp 
    regEx1.Global = True
    
    For Each Match in Matches
      ' find <title>  and <link> entry
      regEx1.Pattern = "  <title>(.*?)</title>  <link>(.*?)</link>" 'Pattern string
      Set Matches1 = regEx1.Execute(Match)
      Set m = Matches1(0)
      f.write  m.SubMatches(0)
      f.write  "%l" & Browser & " "
      f.write  m.SubMatches(1) & VbNewLine
    Next
    
    f.close
    Set f      = nothing
    Set regEx  = nothing
    Set regEx1 = nothing
    GetInformation = "Stand: " & Date() & " " & Time() & " "
  Else
    GetInformation = "Stand: " & DateValue(fs.GetFile(SamurizeDir & heiseFile).DateLastModified) & " " & TimeValue(fs.GetFile(SamurizeDir & heiseFile).DateLastModified)
  End If
  Set fs = nothing
End Function


Function GetHeadline(varCount)
  Dim str, count
  'Create File System Object
  Set fs = CreateObject("Scripting.FileSystemObject")

  'Check to see if the file exists
  if(fs.FileExists(SamurizeDir & heiseFile) = true) then
    'Open the File and read in the information
    Set f = fs.OpenTextFile(SamurizeDir & heiseFile, 1, false)
    count = 0
    GetHeadline = ""
    do while (f.AtEndOfStream <> true)
      str = f.readLine()
      if count = cint(varCount) then
        GetHeadline = Mid(str, 1, instr(str, "%l") - 1)
        exit do
      End If
      count = count + 1
    loop
    f.close()
  Else
    GetHeadline = "NA"
  End If
End Function


Private Function BinToText(varBinData, intDataSizeInBytes) ' as String 
	Dim objRs 
	Const adFldLong = &H00000080 
	Const adVarChar = 200 
	Set objRS = CreateObject("ADODB.Recordset") 
	objRS.Fields.Append "txt", adVarChar, intDataSizeInBytes, adFldLong 
	objRS.Open 
	objRS.AddNew 
	objRS.Fields("txt").AppendChunk varBinData 
	BinToText = objRS("txt").Value 
	objRS.Close 
	Set objRS = Nothing 
End Function
